#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "graphics.h"
#include "tile.h"
#include "objects.h"
#include "keyboard.h"

void makeobjlist()
{ int i, j;

  for(i=0; i<256; i++)
    for(j=0; j<256; j++)
      if(objmap[i][j]==PLAYER)
        createobject(PLAYER, i*16, j*16);
  for(i=0; i<256; i++)
    for(j=0; j<256; j++)
    { if(objmap[i][j]==BLOB)
        createobject(BLOB, i*16, j*16);
      if(objmap[i][j]==COIN)
        createobject(COIN, i*16, j*16);
      if(objmap[i][j]==SPIKE)
        createobject(SPIKE, i*16, j*16);
      if(objmap[i][j]>=GREENKEY && objmap[i][j]<=BLUEKEY)
        createobject(objmap[i][j], i*16, j*16);
      if(objmap[i][j]>=GREENLOCK && objmap[i][j]<=BLUELOCK)
        createobject(objmap[i][j], i*16, j*16);
      if(objmap[i][j]==BREAKER)
        createobject(BREAKER, i*16, j*16);
      if(objmap[i][j]==MOVINGPLAT)
        createobject(MOVINGPLAT, i*16, j*16);
      if(objmap[i][j]==SPRINGBOARD)
        createobject(SPRINGBOARD, i*16, j*16);
      if(objmap[i][j]==PORTCULLIS)
        createobject(PORTCULLIS, i*16, j*16);
    }
}

void play()
{ int c, c2, ftg=0, fr=0, i, oftg;
  int vx, vy;
  char sp[256];

  findanimatedtiles();
  makeobjlist();

  installkbhandler();
  c=clock();
  while(!ESC)
  { c2=clock();
    while(kbhit()) getch();
    vx=objlist[0].data[0]/256-160;
    vy=objlist[0].data[1]/256-100;
    if(vx<0) vx=0;
    if(vy<0) vy=0;
    if(vx+319>4096) vx=4096-319;
    if(vy+199>4096) vy=4096-199;
    drawscreen(vscreen, vx, vy);
    for(i=nobj-1; i>=0; i--)
      objlist[i].blit(objlist+i, vx, vy);
/*    sprintf(sp, "x:%d y:%d xv:%d yv:%d",
            objlist[0].data[0]/256, objlist[0].data[1]/256,
            objlist[0].data[2], objlist[0].data[3]);
*/
    displaytext(vscreen, 0, 0, sp);
    waitretrace();
    memcpy(screen, vscreen, 64000);
    ftg=(clock()-c2)*100/CLOCKS_PER_SEC;
    oftg=ftg;
    ftg=2;
    while(ftg--)
    { for(i=0; i<nobj; i++)
        objlist[i].advframe(objlist+i);
      for(i=0; i<nanimatedtiles; i++)
        animatetile(animatedtiles+i);
      removeobjects();
    }
    fr++;
  }
  printf("%g FPS", (double)fr/((double)(clock()-c)/CLOCKS_PER_SEC));
  deinstallkbhandler();
}

void mapedit()
{ int o=0;
  int x=0, y=0, vx, vy;
  char c, ctile=0, sp[256];
  FILE *f;

  f=fopen("map", "rb");
  fread(backmap, 256, 256, f);
  fread(objmap, 256, 256, f);
  fclose(f);

  do
  { vx=x*16-160;
    vy=y*16-100;
    if(vx<0) vx=0;
    if(vy<0) vy=0;
    if(vx+319>4096) vx=4096-319;
    if(vy+199>4096) vy=4096-199;
    drawscreen(vscreen, vx, vy);
    drawobjscreen(vscreen, vx, vy);
    blittile(vscreen, o?back:obj, ctile, 0, 0);
    blittranstile(vscreen, obj, 1, x*16-vx, y*16-vy);
    sprintf(sp, "x: %d  y: %d  ctile: %d  %s", x, y, ctile, o?"back":"fore");
    displaytext(vscreen, 32, 0, sp);
    waitretrace();
    memcpy(screen, vscreen, 64000);
    c=getch();
    if(!c) c=getch();
    switch(c)
    { case 'o': o=!o; break;
      case 'H': if(y) y--; break;
      case 'P': if(y<255) y++; break;
      case 'K': if(x) x--; break;
      case 'M': if(x<255) x++; break;
      case ' ': (o?backmap:objmap)[x][y]=ctile; break;
      case '[': if(ctile) ctile--; break; 
      case ']': if(ctile<255) ctile++; break;
      case 13: ctile=(o?backmap:objmap)[x][y]; break;
    }
  }while(c!=27);

  f=fopen("map", "wb");
  fwrite(backmap, 256, 256, f);
  fwrite(objmap, 256, 256, f);
  fclose(f);
}

void loadstuff()
{ FILE *f;

  loadpcx(back, "back.pcx");
  loadpcx(obj, "obj.pcx");
  f=fopen("font.bin", "rb");
  fread(font, 7776, 1, f);
  fclose(f);
}

main()
{ loadstuff();
  setmode(0x13);
  setpal(pcxpal);
  mapedit();
  play();
  setmode(0x3);
}
